<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6"
            style="text-align: center"
          >
          Listado de Deudores
          </div>
        </q-card-section>
        <q-card-section v-if="band">
          <q-input
            filled
            v-model="filter"
            @input="filterFN(filter)"
            style="margin-bottom: 1%"
            />
          <q-list bordered padding class="rounded-borders col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
            <q-scroll-area
              style="height:400px;"
              class="full-width"
              >
            <q-item-label header>Estudiantes</q-item-label>
            <q-item clickable v-for="(index, key) in data" :key="key">
              <q-item-section avatar top>
                <q-avatar icon ="school" color="negative" text-color="white"/>
              </q-item-section>
              <q-item-section>
                <q-item-label lines="1">{{index.name}}</q-item-label>
                <q-item-label caption>{{index.carrera}}</q-item-label>
              </q-item-section>
              <q-item-section side v-for="(btn, key) in index.actions" :key="key">
                <q-btn
                  :icon="btn.icon"
                  :color="btn.color"
                  @click="Debts(index)"
                >
                <q-tooltip  content-class="bg-white text-black shadow-4" :offset="[10, 10]">
                  {{btn.title}}
                </q-tooltip>
                </q-btn>
              </q-item-section>
            </q-item>
            </q-scroll-area>
          </q-list>
        </q-card-section>
        <q-card-section v-if="!band" class="text-h7 text-grey">
            No hay aspirantes deudores
        </q-card-section>
        <q-card-section>
          <q-dialog v-model="persistent" persistent transition-show="scale" transition-hide="scale">
            <q-card class="bg-secondary text-white" style="width: 300px">
              <q-card-section>
                <div class="text-h6 text-center">Atencion</div>
              </q-card-section>
              <q-card-section class="q-pt-none">
                {{ alumno.name }} aspirante de {{ alumno.carrera }} posee una deuda de <strong>{{alumno.count}}</strong> por concepto de {{alumno.concept}} <strong><br/> ¿Desea pagar deuda y pasar al siguiente paso del proceso de admision?</strong>
              </q-card-section>
              <q-card-actions align="right" class="bg-white text-black">
                <q-btn flat label="Ok" @click="BuyDebts()"/>
              </q-card-actions>
            </q-card>
          </q-dialog>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<script>
export default {
  data () {
    return {
      copy: [],
      alumno: {},
      selection: [],
      filter: '',
      data: [],
      persistent: false,
      band: false
    }
  },
  mounted () {
    this.getBack()
  },
  methods: {
    getBack () {
      this.$q.loading.show()
      this.$api.get('GetBebts').then(res => {
        this.data = res
        for (const i in this.data) {
          this.data[i].count = this.formatPrice(this.data[i].count)
        }
        this.copy = this.data
        if (this.copy.length === 0) {
          this.band = false
        } else {
          this.band = true
        }
        this.$q.loading.hide()
      })
    },
    formatPrice (value) {
      const val = (value / 1).toFixed(2).replace('.', ',')
      return val.replace(/\B(?=(\d{3})+(?!\d))/g, '.')
    },
    Debts (url) {
      this.filterFN('')
      this.filter = ''
      this.alumno = {}
      this.alumno.carrera = url.carrera
      this.alumno.name = url.name
      this.alumno.count = url.count
      this.alumno.concept = url.concept
      this.alumno.dni = url.dni
      this.persistent = true
      console.log(this.alumno, 'jbkb')
    },
    BuyDebts () {
      this.$q.loading.show()
      this.$api.post('AprovatedDebts/' + this.alumno.dni).then(res => {
        this.getBack()
        this.clearIn()
        this.$q.loading.hide()
      })
    },
    filterFN (valuee) {
      if (valuee === '') {
        this.data = this.copy
      } else {
        const filtred = this.data.filter((obj) => {
          let flag = false
          Object.values(obj).forEach((val) => {
            if (String(val).indexOf(valuee) > -1) {
              flag = true
            }
          })
          if (flag) return obj
        })
        this.data = filtred
      }
    },
    clearIn () {
      this.persistent = false
      this.alumno = []
    }
  }
}
</script>
